program code940;

uses gbaregs;

const gba_regbase = $80000;
      gba_page0   = $90000;
      gba_page1   = $9A000;
      gba_palbase = $A8000;

var k:cardinal;

procedure do_frame_mode_4;

var i,j,c:cardinal;
    bc:word;
    src:Pbyte;
    dst:Pword;


begin
    if Pword(gba_regbase+REG_DISPCNT_L)^ and $10=0 then
	  begin
	  bc:=$7fff;
      src:=Pbyte(gba_page0)
	  end
	else
	  begin
	  bc:=$0ff0;
      src:=Pbyte(gba_page1);
	  end;
    dst:=Pword($00101000);
    dst^:=$ffff;
	
    for i:=0 to 159 do
      begin
        Pword(gba_regbase+REG_VCOUNT)^:=i;
        for j:=0 to 239 do
		  begin
            c:=src^;
            {Get GBA colour though palette lookup.}
            c:=Pword(gba_palbase+2*src^)^;
            {Convert gba colour to gp2x colour.}
            c:=((c and $1f) shl 11) or ((c and $03e0) shl 1) or (c shr 10);
            dst^:=c;
			inc(src);
			inc(dst);
		  end;
		for j:=240 to 319 do
		  begin
		    dst^:=bc;
			inc(dst);
		  end;
      end;
    for j:=0 to 239 do
	   begin
         dst^:=bc;
		 inc(dst);
	   end;
	inc(k);
    {Vblank time. Set VCOUNT to 160 and do a delay loop to give
	 the 920 some time to do things.}
    Pword(gba_regbase+REG_VCOUNT)^:=160;
    for i:=0 to 1023 do;
end;


begin
  k:=0;
  repeat
    Pword($00101000+320*240*2-2)^:=not Pword($00101000+320*240*2-2)^;
    case Pword(gba_regbase+REG_DISPCNT_L)^ and 7 of
      0:;
      1:;
      2:;
      3:;
      4:
        do_frame_mode_4;
      5:;
    end;
  until false;
end.
