unit gp2xhw;

interface

const {Clock registers.}
      PWMODEREG     = $0900 shr 1;
      SYSCLKENREG   = $0904 shr 1;

      {Dual cpu registers.}
      DUAL920DATA0  = $3B00 shr 1;
      DUAL920DATA1  = $3B02 shr 1;
      DUAL920DATA2  = $3B04 shr 1;
      DUAL920DATA3  = $3B06 shr 1;
      DUAL920DATA4  = $3B08 shr 1;
      DUAL920DATA5  = $3B0A shr 1;
      DUAL920DATA6  = $3B0C shr 1;
      DUAL920DATA7  = $3B0E shr 1;
      DUAL920DATA8  = $3B10 shr 1;
      DUAL920DATA9  = $3B12 shr 1;
      DUAL920DATA10 = $3B14 shr 1;
      DUAL920DATA11 = $3B16 shr 1;
      DUAL920DATA12 = $3B18 shr 1;
      DUAL920DATA13 = $3B1A shr 1;
      DUAL920DATA14 = $3B1C shr 1;
      DUAL920DATA15 = $3B1E shr 1;

      DUAL940DATA0  = $3B20 shr 1;
      DUAL940DATA1  = $3B22 shr 1;
      DUAL940DATA2  = $3B24 shr 1;
      DUAL940DATA3  = $3B26 shr 1;
      DUAL940DATA4  = $3B28 shr 1;
      DUAL940DATA5  = $3B2A shr 1;
      DUAL940DATA6  = $3B2C shr 1;
      DUAL940DATA7  = $3B2E shr 1;
      DUAL940DATA8  = $3B30 shr 1;
      DUAL940DATA9  = $3B32 shr 1;
      DUAL940DATA10 = $3B34 shr 1;
      DUAL940DATA11 = $3B36 shr 1;
      DUAL940DATA12 = $3B38 shr 1;
      DUAL940DATA13 = $3B3A shr 1;
      DUAL940DATA14 = $3B3C shr 1;
      DUAL940DATA15 = $3B3E shr 1;

      DUALINT920    = $3B40 shr 1;
      DUALINT940    = $3B42 shr 1;
      DUALPEND920   = $3B44 shr 1;
      DUALPEND940   = $3B46 shr 1;
      DUALCTRL940   = $3B48 shr 1;

var gp2xreg:Pword;

implementation

uses baseunix,unix;

var fd:cint;

begin
  fd:=fpopen('/dev/mem',O_RDWR);
  writeln(fd);
  if fd=-1 then
    runerror(100);
  gp2xreg:=fpmmap(nil,$10000,PROT_READ or PROT_WRITE,MAP_SHARED,fd,$c0000000);
  if cint(gp2xreg)=-1 then
    runerror(100);
  fpclose(fd);
end.
